# coding: utf-8

"""
    Stadia Maps Geospatial APIs

    The Stadia Maps Geospatial APIs provide you with the data you need to build awesome applications.  # noqa: E501

    The version of the OpenAPI document: 5.0.4
    Contact: support@stadiamaps.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from stadiamaps.models.coordinate import Coordinate

class HeightResponse(BaseModel):
    """
    HeightResponse
    """
    id: Optional[StrictStr] = Field(None, description="An identifier to disambiguate requests (echoed by the server).")
    shape: Optional[conlist(Coordinate)] = None
    encoded_polyline: Optional[StrictStr] = Field(None, description="The input polyline.")
    height: Optional[conlist(StrictInt)] = Field(None, description="The list of heights for each point, in meters. Present if `range` is `false`.")
    range_height: Optional[conlist(conlist(StrictInt))] = Field(None, description="The list of horizontal distances and heights (respectively) for each point, in meters. Present if `range` is `true`.")
    additional_properties: Dict[str, Any] = {}
    __properties = ["id", "shape", "encoded_polyline", "height", "range_height"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> HeightResponse:
        """Create an instance of HeightResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in shape (list)
        _items = []
        if self.shape:
            for _item in self.shape:
                if _item:
                    _items.append(_item.to_dict())
            _dict['shape'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> HeightResponse:
        """Create an instance of HeightResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return HeightResponse.parse_obj(obj)

        _obj = HeightResponse.parse_obj({
            "id": obj.get("id"),
            "shape": [Coordinate.from_dict(_item) for _item in obj.get("shape")] if obj.get("shape") is not None else None,
            "encoded_polyline": obj.get("encoded_polyline"),
            "height": obj.get("height"),
            "range_height": obj.get("range_height")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj

