# coding: utf-8

"""
    Stadia Maps Geospatial APIs

    The Stadia Maps Geospatial APIs provide you with the data you need to build awesome applications.  # noqa: E501

    The version of the OpenAPI document: 5.0.4
    Contact: support@stadiamaps.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, StrictStr, conlist
from stadiamaps.models.route_maneuver import RouteManeuver
from stadiamaps.models.route_summary import RouteSummary

class RouteLeg(BaseModel):
    """
    RouteLeg
    """
    maneuvers: conlist(RouteManeuver, min_items=1) = Field(...)
    shape: StrictStr = Field(..., description="An encoded polyline (https://developers.google.com/maps/documentation/utilities/polylinealgorithm) with 6 digits of decimal precision.")
    summary: RouteSummary = Field(...)
    additional_properties: Dict[str, Any] = {}
    __properties = ["maneuvers", "shape", "summary"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RouteLeg:
        """Create an instance of RouteLeg from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in maneuvers (list)
        _items = []
        if self.maneuvers:
            for _item in self.maneuvers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['maneuvers'] = _items
        # override the default output from pydantic by calling `to_dict()` of summary
        if self.summary:
            _dict['summary'] = self.summary.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RouteLeg:
        """Create an instance of RouteLeg from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RouteLeg.parse_obj(obj)

        _obj = RouteLeg.parse_obj({
            "maneuvers": [RouteManeuver.from_dict(_item) for _item in obj.get("maneuvers")] if obj.get("maneuvers") is not None else None,
            "shape": obj.get("shape"),
            "summary": RouteSummary.from_dict(obj.get("summary")) if obj.get("summary") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj

